//------------------------------------------------------------------
//
//    original idea and tradestation code by John Ehlers
//    this version by mladen
//
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DarkGray
#property indicator_color2 DarkGray
#property indicator_color3 PaleVioletRed
#property indicator_width3 2

//
//
//
//
//

extern int    MMPeriod = 20;
extern int    Price    = PRICE_MEDIAN;
extern double Delta    = 0.5;
extern double Fraction = 0.1;

double mode[];
double fractionUp[];
double fractionDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   SetIndexBuffer(0,fractionUp);
   SetIndexBuffer(1,fractionDn);
   SetIndexBuffer(2,mode);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _price 0
#define _bp    1
#define _peak  2
#define _valey 3
#define Pi 3.141592653589793238462643383279

int start()
{
   int i,k,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   double beta    = MathCos(2.0*Pi/MMPeriod);
   double gamma   = 1.0 / MathCos(4.0*Pi*Delta/MMPeriod);
   double alpha   = gamma -MathSqrt(gamma*gamma-1.0);
   int    dPeriod = 2*MMPeriod;
   
      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         work[r][_bp]    = 0.5*(1.0-alpha)*(work[r][_price]-work[r-2][_price])+beta*(1.0+alpha)*work[r-1][_bp]-alpha*work[r-2][_bp];
         work[r][_peak]  = work[r-1][_peak];
         work[r][_valey] = work[r-1][_valey];
            if (work[r-1][_bp]>work[r][_bp] && work[r-1][_bp]>work[r-2][_bp]) work[r][_peak]  = work[r-1][_bp];
            if (work[r-1][_bp]<work[r][_bp] && work[r-1][_bp]<work[r-2][_bp]) work[r][_valey] = work[r-1][_bp];
         
            //
            //
            //
            //
            //
            
            double mean = work[r][_bp]; for (k=1; k<(dPeriod) && (r-k)>=0; k++) mean += work[r-k][_bp];
                                                                                mean /= k;
            double avgPeak  = work[r][_peak];
            double avgValey = work[r][_valey];
            for (k=1; k<50 && (r-k)>=0; k++)
               {
                  avgPeak  += work[r-k][_peak];
                  avgValey += work[r-k][_valey];
               }
               avgPeak  /= k;
               avgValey /= k;
  
            //
            //
            //
            //
            //
            
            mode[i]       = mean;
            fractionUp[i] = Fraction*avgPeak;
            fractionDn[i] = Fraction*avgValey;
         }               
   return(0);
}